<?php
 namespace MongoDB\Operation;
 use MongoDB\Driver\Command;
 use MongoDB\Driver\Exception\RuntimeException as DriverRuntimeException;
 use MongoDB\Driver\Server;
 use MongoDB\Driver\Session;
 use MongoDB\Driver\WriteConcern;
 use MongoDB\Exception\InvalidArgumentException;
 use MongoDB\Exception\UnsupportedException;
 use function current;
 use function is_array;
 use function is_bool;
 use function is_integer;
 use function is_object;
 use function is_string;
 use function MongoDB\server_supports_feature;
 use function trigger_error;
 use const E_USER_DEPRECATED;
 class CreateCollection implements Executable {
 const USE_POWER_OF_2_SIZES = 1;
 const NO_PADDING = 2;
 private static $wireVersionForCollation = 5;
 private static $wireVersionForWriteConcern = 5;
 private $databaseName;
 private $collectionName;
 private $options = [];
 public function __construct($databaseName, $collectionName, array $options = []) {
 if (isset($options['autoIndexId']) && ! is_bool($options['autoIndexId'])) {
 throw InvalidArgumentException::invalidType('"autoIndexId" option', $options['autoIndexId'], 'boolean');
 }
 if (isset($options['capped']) && ! is_bool($options['capped'])) {
 throw InvalidArgumentException::invalidType('"capped" option', $options['capped'], 'boolean');
 }
 if (isset($options['collation']) && ! is_array($options['collation']) && ! is_object($options['collation'])) {
 throw InvalidArgumentException::invalidType('"collation" option', $options['collation'], 'array or object');
 }
 if (isset($options['flags']) && ! is_integer($options['flags'])) {
 throw InvalidArgumentException::invalidType('"flags" option', $options['flags'], 'integer');
 }
 if (isset($options['indexOptionDefaults']) && ! is_array($options['indexOptionDefaults']) && ! is_object($options['indexOptionDefaults'])) {
 throw InvalidArgumentException::invalidType('"indexOptionDefaults" option', $options['indexOptionDefaults'], 'array or object');
 }
 if (isset($options['max']) && ! is_integer($options['max'])) {
 throw InvalidArgumentException::invalidType('"max" option', $options['max'], 'integer');
 }
 if (isset($options['maxTimeMS']) && ! is_integer($options['maxTimeMS'])) {
 throw InvalidArgumentException::invalidType('"maxTimeMS" option', $options['maxTimeMS'], 'integer');
 }
 if (isset($options['session']) && ! $options['session'] instanceof Session) {
 throw InvalidArgumentException::invalidType('"session" option', $options['session'], Session::class);
 }
 if (isset($options['size']) && ! is_integer($options['size'])) {
 throw InvalidArgumentException::invalidType('"size" option', $options['size'], 'integer');
 }
 if (isset($options['storageEngine']) && ! is_array($options['storageEngine']) && ! is_object($options['storageEngine'])) {
 throw InvalidArgumentException::invalidType('"storageEngine" option', $options['storageEngine'], 'array or object');
 }
 if (isset($options['typeMap']) && ! is_array($options['typeMap'])) {
 throw InvalidArgumentException::invalidType('"typeMap" option', $options['typeMap'], 'array');
 }
 if (isset($options['validationAction']) && ! is_string($options['validationAction'])) {
 throw InvalidArgumentException::invalidType('"validationAction" option', $options['validationAction'], 'string');
 }
 if (isset($options['validationLevel']) && ! is_string($options['validationLevel'])) {
 throw InvalidArgumentException::invalidType('"validationLevel" option', $options['validationLevel'], 'string');
 }
 if (isset($options['validator']) && ! is_array($options['validator']) && ! is_object($options['validator'])) {
 throw InvalidArgumentException::invalidType('"validator" option', $options['validator'], 'array or object');
 }
 if (isset($options['writeConcern']) && ! $options['writeConcern'] instanceof WriteConcern) {
 throw InvalidArgumentException::invalidType('"writeConcern" option', $options['writeConcern'], WriteConcern::class);
 }
 if (isset($options['writeConcern']) && $options['writeConcern']->isDefault()) {
 unset($options['writeConcern']);
 }
 if (isset($options['autoIndexId'])) {
 trigger_error('The "autoIndexId" option is deprecated and will be removed in a future release', E_USER_DEPRECATED);
 }
 $this->databaseName = (string) $databaseName;
 $this->collectionName = (string) $collectionName;
 $this->options = $options;
 }
 public function execute(Server $server) {
 if (isset($this->options['collation']) && ! server_supports_feature($server, self::$wireVersionForCollation)) {
 throw UnsupportedException::collationNotSupported();
 }
 if (isset($this->options['writeConcern']) && ! server_supports_feature($server, self::$wireVersionForWriteConcern)) {
 throw UnsupportedException::writeConcernNotSupported();
 }
 $cursor = $server->executeWriteCommand($this->databaseName, $this->createCommand(), $this->createOptions());
 if (isset($this->options['typeMap'])) {
 $cursor->setTypeMap($this->options['typeMap']);
 }
 return current($cursor->toArray());
 }
 private function createCommand() {
 $cmd = ['create' => $this->collectionName];
 foreach (['autoIndexId', 'capped', 'flags', 'max', 'maxTimeMS', 'size', 'validationAction', 'validationLevel'] as $option) {
 if (isset($this->options[$option])) {
 $cmd[$option] = $this->options[$option];
 }
 }
 foreach (['collation', 'indexOptionDefaults', 'storageEngine', 'validator'] as $option) {
 if (isset($this->options[$option])) {
 $cmd[$option] = (object) $this->options[$option];
 }
 }
 return new Command($cmd);
 }
 private function createOptions() {
 $options = [];
 if (isset($this->options['session'])) {
 $options['session'] = $this->options['session'];
 }
 if (isset($this->options['writeConcern'])) {
 $options['writeConcern'] = $this->options['writeConcern'];
 }
 return $options;
 }
 }
 